//---------------------------------------------------------------------------
//
// TDirectDrawForm v1.0 - Flicker free form combining Borland's C++ Builder
// --------------------    and Microsoft's DirectDraw(tm)
//
// (c) 1997,1998 by Darren John Dwyer - All Rights Reserved
//
//
// Disclaimer:
//
// All source code, object files, documentation files, etc. included as
// part this package are supplied subject to the rules in the attached file
// LICENCE.TXT
//
// Please read the file LICENCE.TXT now.
//
//---------------------------------------------------------------------------
#ifndef TDirectDrawFormH
#define TDirectDrawFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Grids.hpp>
#include <vcl\MPlayer.hpp>
#include <vcl\Menus.hpp>
//---------------------------------------------------------------------------
#include "TDirectDraw.h"
//---------------------------------------------------------------------------
class TDirectDrawForm : public TForm
{
    //----------------------------------------------------------------------------------
	// General Notes:
    //
    // (1)	This object "TDirectDrawForm" is designed to be used with the "TDirectDraw"
    //		object written by the same author and will not work without "TDirectDraw".
    //
    // (2)	The TDirectDrawForm behaves exactly the same as the standard TForm
    //		in the manner of dropping components onto the form, etc.
    //
    // (3)	The TDirectDrawForm automatically draws all ::OnPaint() graphics code with
    //      no flicker.
	//
    //----------------------------------------------------------------------------------

__published:
public:

    //----------------------------------------------------------------------------------
    // Use the Transparent property to make your form transparent.
    //----------------------------------------------------------------------------------

    __property	bool			Transparent = {read=fTransparent,write=fTransparent,default=false};

    //----------------------------------------------------------------------------------
	// FramesFlipped is incremented each time the form is repainted.
    //----------------------------------------------------------------------------------

    __property	unsigned long	FramesFlipped = {read=fFramesFlipped,write=fFramesFlipped,default=0};

    //----------------------------------------------------------------------------------
    // When painting it may be handy to exclude all other visible forms from the
    // display area.
    // Params: 	Handle	- pass a valid TForm->Handle and it will be excluded.
    //					- NULL means that all other forms will be excluded.
    //			hdc		- the device context that the form is to be excluded from.
    //----------------------------------------------------------------------------------

	void 		__fastcall	ExcludeOtherForms( HWND Handle, HDC hdc );

    //----------------------------------------------------------------------------------
    // Notes:	Other modified / overloaded methods
    //----------------------------------------------------------------------------------

					__fastcall 	TDirectDrawForm(TComponent* Owner);
	virtual			__fastcall 	~TDirectDrawForm();
    virtual void	__fastcall	Repaint();

protected:

    //----------------------------------------------------------------------------------
    // Notes:	Internal vars & overloaded methods, etc.
    //----------------------------------------------------------------------------------

	void 		__fastcall	WndProc(Messages::TMessage &Message);
	void 		__fastcall	PaintHandler(Messages::TWMPaint &Message);
	void		__fastcall	PaintWindow(HDC hdc);
	void		__fastcall	PaintControls(HDC hdc, TControl* First);

    void		__fastcall	OnException(TObject* Sender, Sysutils::Exception* exception);
    void		__fastcall	OnIdle(TObject* Sender, bool &done);
    void        __fastcall  OnRestore(TObject* Sender);

private:

    //----------------------------------------------------------------------------------
    // Notes:	Internal vars & methods, etc.
    //----------------------------------------------------------------------------------

    unsigned long		fFramesFlipped;
    bool				fTransparent;
    
    bool				var1;
    bool				var2;
    int					var3;
    int					var4;
    bool				var5;
    bool				var6;
    bool				var7;
    bool				var8;
    bool				var9;
    bool				var10;
    bool				var11;
    bool				var12;
    int					var13;
    int                 var14;
	int					var15;
	int					var16;
	int					var17;
    int					var18;
    int					var19;
    int					var20;
    int					var21;
    int					var22;
    int					var23;
    bool				var24;
    TRect				var25;
    int					var34;
    int					var35;
    int					var36;
    bool				var37;
    bool				var38;
    int                 var40;

    void        __fastcall  func1();
    
    TRect       __fastcall	func11( TCanvas* canvas, TRect form_r );
    void		__fastcall	func12( TCanvas* canvas, TRect client_r );

	void 		__fastcall	func21( TCanvas* canvas, int left, int top, int right, int bottom );
	void 		__fastcall 	func22( TCanvas* canvas, int left, int top, int right, int bottom );

    void		__fastcall	func31( TCanvas* canvas, TRect paint_r );
    void		__fastcall	func32( TCanvas* canvas, TRect paint_r );
    void		__fastcall	func33( TCanvas* canvas, TRect paint_r );
    void		__fastcall	func34( TCanvas* canvas, TRect paint_r );

	void		__fastcall 	func41( TCanvas* canvas, TRect client_r );
	void        __fastcall	func42( TCanvas* canvas, TRect client_r, bool paint=true );
	void        __fastcall	func43( TCanvas* canvas, TRect client_r, bool paint=true );

	void		__fastcall	func51( HDC hdc, TListBox* listbox );
	void 		__fastcall	func52( TCanvas* canvas, TListBox* listbox, int rowsperpage );

    System::AnsiString	__fastcall func61( int message, int wparam, int lparam );

	void		__fastcall	func71( HDC hdc, HMENU hmenu );
};
//---------------------------------------------------------------------------
extern TDirectDrawForm *DirectDrawForm;
//---------------------------------------------------------------------------
#endif


